# ce script contient des fonctions utilisees dans les scripts 2, 3 et 4
# trois fonctions de recuperation des données via les API de gallica
# et une fonction qui transforme une variable issue de l'API en taille de police



#################################################################
recup_url_txt <- function(num_tome){
  
  url_txt <- paste("https://gallica.bnf.fr/ark:/12148/"
                   ,ark[num_tome]
                   ,pages[num_tome]
                   ,"texteBrut"
                   ,sep="", collapse = NULL)
  return(url_txt)
}


##################################################################
recup_url_sty <- function(num_tome,num_page){
  url_sty  <- paste("https://gallica.bnf.fr/RequestDigitalElement?O="
                    ,ark[num_tome]
                    ,"&E=ALTO&Deb="
                    ,as.character(num_page)
                    ,sep="",collapse = NULL)
  return(url_sty)
}


####################################################################
recup_url_tdm <- function(num_tome){
  url_tdm  <- paste("https://gallica.bnf.fr/services/Toc?ark=ark:/12148/"
                    ,ark[num_tome]
                    ,sep="",collapse = NULL)
  return(url_tdm)
}




##############################################################
# la fonction font_size_para 
# permet d'obtenir la taille de la police des premiers caracteres du paragraphe
# a partir de la variable TXT récupérée par le script3 
####################################################################

font_size_para=function(num_tome,x1) {
  x2<-x1

  x2[(num_tome==8 & x1==14)] <-4
  x2[(num_tome==8 & x1==16)] <-6
  x2[(num_tome==8 & x1==4 )] <-7
  x2[(num_tome==8 & x1==15)] <-8
  x2[(num_tome==8 & x1==6 )] <-9
  x2[(num_tome==8 & x1==8 )] <-10
  x2[(num_tome==8 & x1==3 )] <-14
  x2[(num_tome==8 & x1==9 )] <-17
  
  x2[(num_tome==9 & x1==13)] <-4
  x2[(num_tome==9 & x1==6 )] <-5
  x2[(num_tome==9 & x1==10)] <-6
  x2[(num_tome==9 & x1==5 )] <-7
  x2[(num_tome==9 & x1==11)] <-8
  x2[(num_tome==9 & x1==3 )] <-9
  x2[(num_tome==9 & x1==8 )] <-10
  x2[(num_tome==9 & x1==7 )] <-12
  x2[(num_tome==9 & x1==9 )] <-16
  
  x2[(num_tome==10 & x1==4 )] <-5
  x2[(num_tome==10 & x1==13)] <-6
  x2[(num_tome==10 & x1==10)] <-7
  x2[(num_tome==10 & x1==3 )] <-8
  x2[(num_tome==10 & x1==5 )] <-9
  x2[(num_tome==10 & x1==8 )] <-10
  x2[(num_tome==10 & x1==14)] <-12
  x2[(num_tome==10 & x1==9 )] <-16
  
  x2[(num_tome==11 & x1==14)] <-4
  x2[(num_tome==11 & x1==12)] <-6
  x2[(num_tome==11 & x1==5 )] <-7
  x2[(num_tome==11 & x1==11)] <-8
  x2[(num_tome==11 & x1==7 )] <-9
  x2[(num_tome==11 & x1==9 )] <-10
  x2[(num_tome==11 & x1==13)] <-13
  x2[(num_tome==11 & x1==10)] <-17
  
  x2[(num_tome==12 & x1==17)] <-4
  x2[(num_tome==12 & x1==5 )] <-5
  x2[(num_tome==12 & x1==16)] <-6
  x2[(num_tome==12 & x1==3 )] <-7
  x2[(num_tome==12 & x1==15)] <-8
  x2[(num_tome==12 & x1==6 )] <-9
  x2[(num_tome==12 & x1==8 )] <-10
  x2[(num_tome==12 & x1==7 )] <-12
  x2[(num_tome==12 & x1==18)] <-15
  x2[(num_tome==12 & x1==13)] <-16
  
  return(x2)
}
#######################################################"
