#ce script permet de récupérer la taille de police des premiers caractères 
#d'un paragraphe à partir de l'API de gallica


######################################### 
# la fonction recup_sty 
#########################################

recup_sty=function(num_tome){

 #creation d'un dataframe vide qui sera alimenté au fur et à mesure
 df_temp <- data.frame(0,0,0,0,0)
 colnames(df_temp) <- c("num_tome","num_page","nb_parap","num_parap","taille_pol") 
 
 #initialisation
 style <- NULL
 current_stylerefs <- NULL

 #boucle sur les pages
  for (page in page_deb[num_tome]:page_fin[num_tome]) {
  #récupération de la page xml en cours 
   page_url<- recup_url_sty(num_tome,page)
   page_xml<- read_html(page_url)
  #récupération de l'ensemble des noeuds de la page en cours  
   blocknodes <- page_xml %>% xml_node('body')  %>% xml_nodes('printspace') %>% xml_nodes('textblock')
  # récupération du nombre de blocks (ou paragraphes) de la page en cours
   nb_blocks <- length(blocknodes)
  
  #boucle sur tous les paragraphes de la page en cours
  for (num_block in 1:nb_blocks) {
    #récupération des lignes du paragraphes en cours
    linenodes    <- blocknodes [[num_block]] %>% xml_nodes('textline') 
    #récupération des mots de la premiere ligne du paragraphe en cours
    stringnodes  <- linenodes[[1]] %>% xml_nodes('string')
    #récupération du nombre de mots de la première ligne du paragraphe en cours    
    nb_mots <- length(stringnodes)
    
    #boucle sur les 5 premiers mots du paragraphe en cours
     for (num_mot in 1:5) { 
     style[num_mot] <- NA 
     if (nb_mots>=num_mot)  {
       current_stylerefs[num_mot] <-  xml_attrs(stringnodes[[num_mot]])[["stylerefs"]]
       style[num_mot] <- as.numeric(substr(current_stylerefs[num_mot], 5, 6)) 
       }
     }
    #fin boucle sur les 5 premiers mots

    # définition du style du paragraphe comme le style le plus fréquent
    df_mots <- as.data.frame(style)  
    sty_para <- as.numeric(names(sort(-table(df_mots)))[1])
    taille_pol <- font_size_para(num_tome,sty_para)

    #correction de num_page pour qu 'il commence à 1
    num_page=page-page_deb[num_tome]+1
    
    # alimentation du dataframe df_temp
    vector_block <- c(num_tome,num_page,nb_blocks,num_block,taille_pol)
    df_temp <- rbind(df_temp,vector_block,stringsAsFactors = FALSE)
    
  #fin de la boucle sur les paragraphes  
  }
 # fin de la boucle sur les pages
 }

 # suppression de la premiere ligne
 df_sty  <- df_temp %>% filter(num_tome!=0)
 return(df_sty)
}

df8_sty <- recup_sty(8)
df9_sty <- recup_sty(9)
df10_sty <- recup_sty(10)
df11_sty <- recup_sty(11)
df12_sty <- recup_sty(12)


