# ce script permet de récupérer la table des matières du tome 12
# à partir de l'API de Gallica

#######################################
# la fonction recup_tdm12 
#######################################



recup_tdm12=function(){

tdm_url <- recup_url_tdm(12)
page_xml<- read_xml(tdm_url,encoding="ISO-8859-1")

# 1 recuperation de tous les titres de depeche
titres_path <- xml_find_all(page_xml, xpath="//div1/div2/table/row/cell/seg")

#nombre de depeches dans le tome
nb_depeches <-length(titres_path)
#meta_donnees
meta_dep <- xml_text(titres_path)
#data frame
df_tdm <- as.data.frame(meta_dep,stringsAsFactors = FALSE) 


#####corrections ligne double
df_tdm_a <- df_tdm %>% slice(1:16)
df_tdm_b <- df_tdm %>% slice(16)
df_tdm_c <- df_tdm %>% slice(17:364)
df_tdm_d <- df_tdm %>% slice(364:364)
df_tdm_e <- df_tdm %>% slice(365:373)

df_tdm <- rbind(df_tdm_a,df_tdm_b,df_tdm_c,df_tdm_d,df_tdm_e)  

df_tdm$meta_dep[16] <- "Benedetti, Ambassadeur à Berlin, à Drouyn de Lhuys. (Télégr., 2h 12 soir.)"  
df_tdm$meta_dep[17] <-  "Drouyn de Lhuys à Benedetti, Ambassadeur à Berlin. (Télégr.)"  

df_tdm$meta_dep[365] <- "Le Marquis de Moustier au Baron de Malaret, Ministre à Florence. (N° 71.)"
df_tdm$meta_dep[366] <- "Lefebvre de Béhaine, Chargé d?Affaires à Berlin, au Marquis de Moustier. (N° 233.)"

#suppression des dernieres lignes
df_tdm <- df_tdm %>% slice(1:370)


####################################################
# 2 recuperation de toutes les dates de depeche
dates_path <- xml_find_all(page_xml,xpath="//div1/div2/head")
#nombre de dates de depeches
nb_dates <- length(dates_path)
#  dates de depeches
dates_depeches <- xml_text(dates_path)

####################################################
# 3 recuperation du nombre de depeches par date de depeche
depeches_date_path <- xml_find_all(page_xml, xpath="//div1/div2/table")
nb_depeches_date <- xml_length(depeches_date_path)


####################################################
# 4 recuperation de tous les mois de depeche
mois_path <- xml_find_all(page_xml, xpath="//div1/head")
#nombre de mois de depeches
nb_mois <- length(mois_path)
#  mois de depeches
mois_depeches <- xml_text(mois_path)


####################################################
# 5 recuperation du nombre de dates par mois
dates_mois_path <- xml_find_all(page_xml, xpath="//div1")
#nombre de dates par mois
nb_dates_mois <- xml_length(dates_mois_path)-1


####################################################
# 6 une correction specifique pour le tome
#due a des erreurs dans la structure xml

length(nb_depeches_date) <-68  
nb_dates_mois[3] <-14
nb_depeches_date[1] <-8
nb_depeches_date[2] <-23

####################################################
### 7 utilisation de la fonction rep
mois=rep(mois_depeches,nb_dates_mois)


df_tdm <- df_tdm %>%
  mutate(  num_tome=12,
           date_dep=rep(dates_depeches,nb_depeches_date),  
           mois_dep=rep(mois,nb_depeches_date)
  )

###################################################
return(df_tdm)
}

df12_tdm <-recup_tdm12() 


save.image("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a4.RData")

