# ce script permet de récupérer la table des matières du tome 9
# à partir de l'API de Gallica


#######################################
# la fonction recup_tdm9 
#######################################

recup_tdm9=function(){

  tdm_url <- recup_url_tdm(9)
  page_xml<- read_xml(tdm_url,encoding="ISO-8859-1")
  
  # 1 recuperation de tous les titres de depeche
  titres_path <- xml_find_all(page_xml, xpath="//div1/div2/table/row/cell/seg")

  #nombre de depeches dans la tome
  nb_depeches <-length(titres_path)
  #meta_donnees
  meta_dep <- xml_text(titres_path)
  #data frame
  df_tdm <- as.data.frame(meta_dep,stringsAsFactors = FALSE) 
  

  ####################################################
  # 2 recuperation de toutes les dates de depeche
  dates_path <- xml_find_all(page_xml, xpath="//div1/table")
  #nombre de dates de depeches
  nb_dates <- length(dates_path)
  #  dates de depeches
  dates_depeches <- xml_text(dates_path)

  ####################################################
  # 3 recuperation du nombre de depeches par date de depeche
  depeches_date_path <- xml_find_all(page_xml, xpath="//div1/div2/table")
  nb_depeches_date <- xml_length(depeches_date_path)
  
  
  ####################################################
  # pas d'etape 4 ni 5 
  mois_depeches<- c("MAI 1866.", "JUIN 1866.")
  nb_dates_mois <- c("273","25") 
 
  ####################################################
  # 6  correction specifique au tome
  #due a des disparites dans la structure xml
  
  dates_depeches[1] <- "4 MAI."

  ####################################################
  ### 7 utilisation de la fonction rep
  mois_dep=rep(mois_depeches,nb_dates_mois)
  
  df_tdm <- df_tdm %>%
    mutate(num_tome=9,
           date_dep=rep(dates_depeches,nb_depeches_date),
           mois_dep=rep(mois_depeches,nb_dates_mois))  
  
  #on ote les lignes appendice, notice etc...  
  df_tdm <- df_tdm %>%  slice(1:296)

  return(df_tdm)
}

df9_tdm <- recup_tdm9()


