# ce script permet de récupérer la table des matières des tomes 8 10 et 11
# à partir de l'API de Gallica


#############################*
# la fonction recup_tdm 
##############################
# cette fonction est aplplicable aux tomes  8 10 et 11


recup_tdm=function(num_tome){

tdm_url <- recup_url_tdm(num_tome)
page_xml<- read_xml(tdm_url,encoding="ISO-8859-1")

# 1 recuperation de tous les titres de depeche
titres_path <- xml_find_all(page_xml,xpath="//div1/div2/table/row/cell/seg")

#nombre de depeches dans le tome
nb_depeches <-length(titres_path)
#meta_donnees
meta_dep <- xml_text(titres_path)
#data frame
df_tdm <- as.data.frame(meta_dep,stringsAsFactors = FALSE)

####################################################
# 2 recuperation de toutes les dates de depeche
dates_path <- xml_find_all(page_xml, xpath="//div1/div2/head")
#nombre de dates de depeches
nb_dates <- length(dates_path)
#  dates de depeches
dates_depeches <- xml_text(dates_path)

####################################################
# 3 recuperation du nombre de depeches par date de depeche
depeches_date_path <- xml_find_all(page_xml, xpath="//div1/div2/table")
nb_depeches_date <- xml_length(depeches_date_path)


####################################################
# 4 recuperation de tous les mois de depeche
mois_path <- xml_find_all(page_xml, xpath="//div1/head")
#nombre de mois de depeches
nb_mois <- length(mois_path)
#  mois de depeches
mois_depeches <- xml_text(mois_path)


####################################################
# 5 recuperation du nombre de dates par mois
dates_mois_path <- xml_find_all(page_xml, xpath="//div1")
#nombre de dates par mois
nb_dates_mois <- xml_length(dates_mois_path)-1


####################################################
# 6  correction specifique a chaque tome
#due a des disparites dans la structure xml

if (num_tome==8) {
length(nb_dates_mois) <-3
nb_dates_mois[1]<-16
}

if (num_tome==11) {
  nb_depeches_date[1]<-10
}

####################################################
### 7 utilisation de la fonction rep
mois=rep(mois_depeches,nb_dates_mois)
df_tdm <- df_tdm %>%
  mutate(num_tome=num_tome,
         date_dep=rep(dates_depeches,nb_depeches_date),
         mois_dep=rep(mois,nb_depeches_date) )

####################################################
### 8 modification propre a chaque tome
### suppression des notices, annexe appendices
if (num_tome==8) {
  df_tdm <- df_tdm[-c(346),]
}
if (num_tome==10) {
  df_tdm <- df_tdm[-c(418,419),]
}
if (num_tome==11) {
  df_tdm <- df_tdm[-c(366,367,368),]
}



####################################################
return(df_tdm)
}

df8_tdm <-recup_tdm(8)
df10_tdm <-recup_tdm(10) 
df11_tdm <-recup_tdm(11) 

