# ce script 
# 1) merge les dataframe txt et sty construits dans les scripts 2 et 3
# 2) lit les données des classeurs dans lesquels les paragraphes notes de bas de page 
# ont été cochés manuellement
# 3) et les merge aux dataframes obtenus en 1)


load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a4.RData")
setwd("D:/memoire m2_LNakache/constitution du corpus/nbp")


########################################################
# la fonction merge_text_et_sty 
########################################################☻

merge_text_et_sty <- function(df_txt,df_sty) {
  df_txt  <- df_txt %>%
    mutate(pageparag=paste(num_page,num_parap))
  df_sty  <- df_sty %>%
    mutate(pageparag=paste(num_page,num_parap))
  
  df_txt_sty <- merge(df_txt,df_sty,by="pageparag")%>%
    mutate(num_tome=num_tome.x,
           nb_parap=nb_parap.x,
           num_parap=num_parap.x,
           num_page=num_page.x) %>%
    arrange(num_page,num_parap) %>%
    select(num_tome, num_page, nb_parap, num_parap, texte, taille_pol, pageparag)

   return(df_txt_sty)
}


df8_txt_sty  <- merge_text_et_sty(df8_txt,df8_sty)
df9_txt_sty  <- merge_text_et_sty(df9_txt,df9_sty)
df10_txt_sty <- merge_text_et_sty(df10_txt,df10_sty)
df11_txt_sty <- merge_text_et_sty(df11_txt,df11_sty)
df12_txt_sty <- merge_text_et_sty(df12_txt,df12_sty)



#correction pour le tome 9 dans lequel les pages 28 à 37 sont en double
df9_txt_sty <- df9_txt_sty %>%
  filter(!(num_tome==9 & num_page>=28 & num_page<=37)) %>%
  mutate(
    num_page=ifelse(num_tome==9 & num_page>=28,num_page-10,num_page),
    pageparag=paste(num_page,num_parap)
  ) 

############################################
#lecture des donnees
############################################

df8_nbp <-  read_delim("nbp8.txt", delim=";")
df9_nbp <-  read_delim("nbp9.txt", delim=";")
df10_nbp <- read_delim("nbp10.txt", delim=";")
df11_nbp <- read_delim("nbp11.txt", delim=";")
df12_nbp <- read_delim("nbp12.txt", delim=";")


############################################
#merge avec le dataframe df_txt_sty
############################################
merge_text_sty_et_nbp <- function(df_txt_sty, df_nbp) {
  
  df_nbp <- df_nbp %>%
    mutate(
      V1 = 1 ,
      nb_para  = ave(V1, num_page, FUN = sum),  #nb de paragraphes dans la page
      num_para=nb_para+1-num_inv_parap,         #numero du paragraphe 
      pageparag=paste(num_page,num_para)
    ) %>%
    select(pageparag,note_bp)
  
  
  df_txt_sty_nbp <- merge(df_txt_sty,df_nbp,by="pageparag") %>%
    arrange(num_page,num_parap) %>%
    select(-pageparag)
  
  return(df_txt_sty_nbp)
}



df8_txt_sty_nbp <- merge_text_sty_et_nbp(df8_txt_sty, df8_nbp)
df9_txt_sty_nbp <- merge_text_sty_et_nbp(df9_txt_sty, df9_nbp)
df10_txt_sty_nbp <- merge_text_sty_et_nbp(df10_txt_sty, df10_nbp)
df11_txt_sty_nbp <- merge_text_sty_et_nbp(df11_txt_sty, df11_nbp)
df12_txt_sty_nbp <- merge_text_sty_et_nbp(df12_txt_sty, df12_nbp)






