# ce script merge les données des tables des matières récupérées dans les script 4
# aux dataframes créés à l'étape précédente
# il traite également les dates de dépêches 


load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a6.RData")

########################################
# la fonction merge_tdm 
#######################################

merge_tdm=function(df_txt_sty_nbp_chr_dep,df_tdm){
  
  ###les dates de depeche#########################
  df_tdm <- df_tdm %>%
    mutate(
      l=str_length(date_dep)-1,
      date=str_sub(date_dep,1,l),
      date_c=paste(date, "1866"),
      date_c=str_trim(date_c),
      date_cc=str_replace_all(date_c,  "MARS",      "03"),
      date_cc=str_replace_all(date_cc, "AVRIL",     "04"),
      date_cc=str_replace_all(date_cc, "MAI",       "05"),
      date_cc=str_replace_all(date_cc, "JUIN",      "06"),
      date_cc=str_replace_all(date_cc, "JUILLET",   "07"),
      date_cc=str_replace_all(date_cc, "AOUT",      "08"),
      date_cc=str_replace_all(date_cc, "SEPTEMBRE", "09"),
      date_cc=str_replace_all(date_cc, "OCTOBRE",   "10"),
      date_cc=str_replace_all(date_cc, " ", "-"),
      date=dmy(date_cc)
    ) %>%
    select(-date_dep,-l,-mois_dep,-date_cc)
  
  # ajout d'une depeche vide a df_tdm 
  # pour simuler la premiere depeche de df_txt_sty_nbp_chr_dep
  # correspondant au titre du tome
  df_tdm <- rbind( c("vide",NA,NA), df_tdm)
  
  #df nombre de paragraphes par depeche
  df_dep_t <- df_txt_sty_nbp_chr_dep %>%
    filter(num_parad==1) %>%
    select(nb_parad)
  
  
  # creation de df_txt_sty_nbp_chr_dep_tdm
  # on ajoute trois variables construits a l aide de rep
  df_txt_sty_nbp_chr_dep_tdm <- df_txt_sty_nbp_chr_dep %>%
    mutate(
      #vecteur meta_dep_t autant de lignes que de paragraphes
      meta_dep = rep(as.vector(df_tdm$meta_dep), as.integer(df_dep_t$nb_parad)),
      date     = rep(as.vector(df_tdm$date),     as.integer(df_dep_t$nb_parad)),
      date_c   = rep(as.vector(df_tdm$date_c),   as.integer(df_dep_t$nb_parad))
    )
      

###############################################

return(df_txt_sty_nbp_chr_dep_tdm)
}


df8_txt_sty_nbp_chr_dep_tdm  <- merge_tdm(df8_txt_sty_nbp_chr_dep, df8_tdm)
df9_txt_sty_nbp_chr_dep_tdm  <- merge_tdm(df9_txt_sty_nbp_chr_dep, df9_tdm)
df10_txt_sty_nbp_chr_dep_tdm <- merge_tdm(df10_txt_sty_nbp_chr_dep,df10_tdm)
df11_txt_sty_nbp_chr_dep_tdm <- merge_tdm(df11_txt_sty_nbp_chr_dep,df11_tdm)
df12_txt_sty_nbp_chr_dep_tdm <- merge_tdm(df12_txt_sty_nbp_chr_dep,df12_tdm)


