# ce script
# 1) reunit tous les datframes des tomes 8 à 12 en un seul data.frame
# 2) supprime les paragraphes notes de bas de page et chronologie
# 3) utilise differentes fonctions pour traiter les métadonnées
# 4) permet d'effectuer des verifications 



# reunion en un seul dataframe
df_txt_sty_nbp_chr_dep_tdm <- rbind(
  df8_txt_sty_nbp_chr_dep_tdm,
  df9_txt_sty_nbp_chr_dep_tdm,
  df10_txt_sty_nbp_chr_dep_tdm,
  df11_txt_sty_nbp_chr_dep_tdm,
  df12_txt_sty_nbp_chr_dep_tdm
)


# suppression des paragraphes notes de bas de page et chronologie
# et calcul du nouveau nombre de paragraphes dans la depeche
df_txt_sty_nbp_chr_dep_tdm_met0 <- df_txt_sty_nbp_chr_dep_tdm %>%
  filter(chr==0 & note_bp==0) %>%
  mutate(
    V1=1,
    nb_new_parad=ave(V1,num_dep,FUN=sum),
    num_new_parad = ave(V1, num_dep, FUN = seq_along) 
  ) %>%
  select(-chr,-note_bp,-V1,-nb_parad,-num_parad )


#corrrections erreurs de frappe et transformatin en espace de certains caracteres
  df_txt_sty_nbp_chr_dep_tdm_met1 <- meta1_espaces_et_fautes_de_frappe(df_txt_sty_nbp_chr_dep_tdm_met0)

#traitement du titre(ambassadeur etc...) des expéditeurs et des destinataires
  df_txt_sty_nbp_chr_dep_tdm_met2 <- meta2_tt_titre(df_txt_sty_nbp_chr_dep_tdm_met1)

#traitement  du changement de MAEDF  
  df_txt_sty_nbp_chr_dep_tdm_met3 <- meta3_maedf(df_txt_sty_nbp_chr_dep_tdm_met2)

#decoupage en 5 segments  
  df_txt_sty_nbp_chr_dep_tdm_met4 <- meta4_decoup_seg(df_txt_sty_nbp_chr_dep_tdm_met3)

#traitement des documents qui ne sont pas des dépeches ;traiement des expediteurs et destinataires 
  df_txt_sty_nbp_chr_dep_tdm_met5 <- meta5_exped_dest(df_txt_sty_nbp_chr_dep_tdm_met4)

#reperage des depeches diplomatiques francaises
  df_txt_sty_nbp_chr_dep_tdm_met6 <- meta6_dep_dip_fr(df_txt_sty_nbp_chr_dep_tdm_met5)

#repérage des telegrammes, lettres particuliere ou confidentielles etc (traitement du segment5) 
  df_txt_sty_nbp_chr_dep_tdm_met <- meta7_tt_seg5(df_txt_sty_nbp_chr_dep_tdm_met6)
  

#verifications
  verif   <- df_txt_sty_nbp_chr_dep_tdm_met %>% filter(num_new_parad==1)
  verif1  <-as.data.frame(table(verif$exped))
  verif2  <-as.data.frame(table(verif$titr_exped))
  verif12 <-as.data.frame(table(verif$exped_t))
  verif3  <-as.data.frame(table(verif$dest))
  verif4  <-as.data.frame(table(verif$titr_dest))
  verif34 <-as.data.frame(table(verif$dest_t))
  table(verif$non_dep,verif$dep_dip_fr,useNA="ifany") 
  verif_non_dep<-verif%>% filter(non_dep==1)
  verif_non_dep_dip_fr<-verif%>% filter(non_dep==0 & dep_dip_fr==0)
  

# nettoyage de l'environnement apres verifications  
rm(verif,verif1,verif2,verif12,verif3,verif4,verif34,
   verif_non_dep,verif_non_dep_dip_fr)
rm(df_txt_sty_nbp_chr_dep_tdm_met0,df_txt_sty_nbp_chr_dep_tdm_met1,
   df_txt_sty_nbp_chr_dep_tdm_met2,df_txt_sty_nbp_chr_dep_tdm_met3,
   df_txt_sty_nbp_chr_dep_tdm_met4,df_txt_sty_nbp_chr_dep_tdm_met5,
   df_txt_sty_nbp_chr_dep_tdm_met6)

save.image("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a8.RData")

