# ce script permet de creer la variable flag_corps_dep qui indique 
# si le paragraphe appartient au corps de depeche
#
# dans un premier temps il cree des flags de reperage
# puis il traite separement les depeches ecrites par le ministre des affaires etrangeres
# et celles ecrites par un agent diplomatique
# avant de les reunir en un seul dataframe


load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a8.RData")



##############################################################
#creation de differents flags de repérage
df_txt_sty_nbp_chr_dep_tdm_met_tit1 <- titr1_prepa(df_txt_sty_nbp_chr_dep_tdm_met)


##############################################################
# 1 depeches ecrites par le ministre des affaires etrangeres 
##############################################################

#creation de flag_der_cas qui indique si le paragraphe est le dernier paragraphe du titre de depeche
df_txt_sty_nbp_chr_dep_tdm_met_tit2 <- titr2_maedf(df_txt_sty_nbp_chr_dep_tdm_met_tit1) 

#correction manuelle de flag_der_cas pour les cas qui n ont pas pu etre traités automatiquement
df_txt_sty_nbp_chr_dep_tdm_met_tit3<- titr3_maedf_corr(df_txt_sty_nbp_chr_dep_tdm_met_tit2) 
  
# creation du flag paragraphe corps de depeche
df_txt_sty_nbp_chr_dep_tdm_met_tit4 <- titr4_maedf_corps(df_txt_sty_nbp_chr_dep_tdm_met_tit3) 


##############################################################
#verifications 
#on attend un et un seul paragraphe fin de titre ( dernier cas) par depeche
verif_table <- as.data.frame(table(df_txt_sty_nbp_chr_dep_tdm_met_tit4$num_dep,df_txt_sty_nbp_chr_dep_tdm_met_tit4$flag_der_cas))
verif_table$Var1[verif_table$Var2==1 & verif_table$Freq==0]
# aucune ligne de frequence 0
verif_table$Var1[verif_table$Var2==1 & verif_table$Freq>=2]
# aucune ligne de frequence 2

#verification visuelle du dernier paragraphe de titre 
#et du premier paragraphe corps de depeche
verif_vv <- df_txt_sty_nbp_chr_dep_tdm_met_tit4 %>% 
  mutate(texte2=lead(texte,n=1)) %>%
    filter(flag_der_cas==1) %>%
    select(num_dep, texte, texte2 )



##############################################################
#nettoyage de l environnement apres verifications
rm(verif_table, verif_vv)


##############################################################
# creation du dataframe pour les depeches écrites par le ministre des affaires etrangeres
df_txt_sty_nbp_chr_dep_tdm_met_tit_maedf <- df_txt_sty_nbp_chr_dep_tdm_met_tit4 %>%
 select(
   -non_dep,-dep_dip_fr,
   -taille_pol, -prec_taille_pol,-post_taille_pol,-lettre,
   -pattern_cab_rec,-pattern_paris,-flag_nonderparpag, -flag_pardep1a5,
   -flag_paris,-flag_cabrec,-flag_court,-flag_tailpol,
   -flag_cas1,-flag_cas2,-flag_cas,-flag_nb_cas,-flag_cum_nbcas,-flag_der_cas)%>%
  mutate(type="maedf")

##########################################################################################
##########################################################################################









##############################################################
# 2 depeches ecrites par un agent diplomatique 
##############################################################


#creation de flag_der_cas qui indique si le paragraphe est le dernier paragraphe du titre de depeche
df_txt_sty_nbp_chr_dep_tdm_met_tit5 <- titr5_amba(df_txt_sty_nbp_chr_dep_tdm_met_tit1) 

#correction manuelle de flag_der_cas pour des cas qui n ont pas pu etre traités automatiquement
df_txt_sty_nbp_chr_dep_tdm_met_tit6<- titr6_amba_corr(df_txt_sty_nbp_chr_dep_tdm_met_tit5) 

# creation du flag paragraphe corps de depeche
df_txt_sty_nbp_chr_dep_tdm_met_tit7 <- titr7_amba_corps(df_txt_sty_nbp_chr_dep_tdm_met_tit6) 


##############################################################
#verifications 
#on attend un et un seul paragraphe fin de titre ( dernier cas) par depeche
verif_table <- as.data.frame(table(df_txt_sty_nbp_chr_dep_tdm_met_tit7$num_dep,df_txt_sty_nbp_chr_dep_tdm_met_tit7$flag_der_cas))
verif_table$Var1[verif_table$Var2==1 & verif_table$Freq==0]
# aucun
verif_table$Var1[verif_table$Var2==1 & verif_table$Freq>=2]
# aucun

#verification visuelle du dernier paragraphe de titre 
#et du premier paragraphe corps de depeche
verif_vv <- df_txt_sty_nbp_chr_dep_tdm_met_tit7 %>% 
  mutate(texte2=lead(texte,n=1)) %>%
  filter(flag_der_cas==1) %>%
  select(num_dep, texte, texte2 )


##############################################################
#nettoyage de l environnement apres verifications
rm(verif_table, verif_vv)


##############################################################
# creation du dataframe pour les depeches écrites par un agent diplomatique
df_txt_sty_nbp_chr_dep_tdm_met_tit_amba <- df_txt_sty_nbp_chr_dep_tdm_met_tit7 %>% 
  select(
    -non_dep,-dep_dip_fr,
    -taille_pol, -prec_taille_pol,-post_taille_pol,-lettre,
    -pattern_cab_rec,-pattern_paris,-flag_nonderparpag, -flag_pardep1a5,
    -flag_paris,-flag_cabrec,-flag_court,-flag_tailpol,
    -flag_cas1,-flag_cas2,-flag_cas3,-flag_cas,-flag_nb_cas,-flag_cum_nbcas,-flag_der_cas,
    -V1,-num_obs,-nb_obs
    )%>%
  mutate(type="adep")
################################################################################



##############################################################################
# 3 combinaison des deux dataframes 
#   ministre des affaires etrangères et agent diplomatique

df_txt_sty_nbp_chr_dep_tdm_met_tit <- rbind(df_txt_sty_nbp_chr_dep_tdm_met_tit_maedf,
                                            df_txt_sty_nbp_chr_dep_tdm_met_tit_amba) %>%
     arrange(num_dep,num_new_parad)


##############################################################################
#nettoyage de l environnement
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit1)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit2)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit3)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit4)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit5)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit6)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit7)

rm(df_txt_sty_nbp_chr_dep_tdm_met_tit_maedf)
rm(df_txt_sty_nbp_chr_dep_tdm_met_tit_amba)

save.image("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a9.RData")

