###################################################################
# ce script permet de construire les histogrammes 
# présentés dans la partie descriptive 
###################################################################


#histogramme  des dates d'envoi - lettres et télégrammes 
p1<- ggplot(desc_corres, aes(x=date, color=factor(teleg))) +
  geom_histogram(position="identity", alpha=0.5,binwidth = 10,fill='grey' ) +
  scale_color_discrete(name = "Dépêches", labels = c("Lettres", "Télégrammes")) +
  labs(title="Figure 3", subtitle="Histogramme des dates d'envoi des dépêches", x="Date d'envoi", y = "Effectif")+
  theme_classic()

p1

#histogramme des dates d'envoi - envoyées et recues par les diplomates 
p2<- ggplot(desc_corres, aes(x=date, color=factor(type))) +
  geom_histogram(position="identity", alpha=0.5,binwidth = 10,fill='grey' ) +
  scale_color_discrete(name = "Dépêches", labels = c("Envoyées", "Reçues")) +
  labs(title="Figure 4", subtitle="Histogramme des dates d'envoi des dépêches", x="Date d'envoi", y = "Effectif")+
  theme_classic()

p2



#####Selection des 8 diplomates pour lesquels on dispose d'au moins 50 depeches
desc_corres_selec8 <- desc_corres %>%
  filter (nom %in% c("Benedetti","Le Duc de Gramont", "Le Baron de Malaret",
                     "Le Prince de La Tour d Auvergne",
                     "Le Vicomte des Méloizes",
                     "Le Baron Forth Rouen","Le Baron de Talleyrand","Le Baron d Avril"))
desc_corres_selec8_lettres <- desc_corres %>%
  filter (nom %in% c("Benedetti","Le Duc de Gramont", "Le Baron de Malaret",
                     "Le Prince de La Tour d Auvergne",
                     "Le Vicomte des Méloizes",
                     "Le Baron Forth Rouen","Le Baron de Talleyrand","Le Baron d Avril")) %>%
  filter(teleg==0)


# Histogramme des dates d'envoi- Lettres et télégrammes par diplomate 
p3<- ggplot(desc_corres_selec8, aes(x=date, color=factor(teleg))) +
  geom_histogram(position="identity",alpha=0.5,binwidth = 10,fill='grey' ) +
  scale_color_discrete(name = "Dépêches", labels = c("Lettres", "Télégrammes")) +
  labs(title="Figure 5 ", subtitle="Histogramme des dates d'envoi des dépêches", x="Date d'envoi", y = "Effectif")+
  theme_classic() +
  facet_wrap( ~ nom,ncol=2) +
  theme(strip.text = element_text(size=8)  ) 


p3

# Histogramme des dates d'envoi- Envoyées Recues par diplomate 
p4 <- ggplot(desc_corres_selec8, aes(x=date, color=factor(type))) +
      geom_histogram(position="identity",alpha=0.5,binwidth = 10,fill='grey' ) +
      scale_color_discrete(name = "Dépêches", labels = c("Envoyées", "Reçues")) +
      labs(title="Figure 6 ", subtitle="Histogramme des dates d'envoi des dépêches", x="Date d'envoi", y = "Effectif")+
      theme_classic() +
      facet_wrap( ~ nom,ncol=2) +
      theme(strip.text = element_text(size=8) )
p4      


###########################################################################################

#histogramme nombre de mots -Lettres et télégrammes
p5<- ggplot(desc_corres, aes(x=nb_mots, color=factor(teleg))) +
  geom_histogram(position="identity", alpha=0.5,binwidth = 50,fill='grey' ) +
  scale_color_discrete(name = "Dépêches", labels = c("Lettres", "Télégrammes")) +
  labs(title="Figure 7 ", subtitle="Histogramme des nombres de mots par dépêche", x="Nombre de mots", y = "Effectif")+
  theme_classic()
p5

#histogramme nombre de mots -Lettres - par diplomates
p6<- ggplot(desc_corres_selec8_lettres, aes(x=nb_mots)) +
  geom_histogram(position="identity", alpha=0.5,binwidth = 100,color='red', fill='grey' ) +
  labs(title="Figure 8 ", subtitle="Histogramme des nombres de mots par dépêche", x="Nombre de mots", y = "Effectif")+
  theme_classic() +
  facet_wrap( ~ nom,ncol=2) +
  theme(strip.text = element_text(size=8) )

p6

