#ce script permet de construire 

#    le data frame df_tdm_en dataframe de type TDM 
#    contenant en lignes les 10560 mots contenus dans les textes de benedetti et de gramont
#    en colonnes les 396 depeches 
#    qui est utilisé  dans le script reseau

load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rdepdipfr.RData")


# Import librarires
library(dplyr)
library(stringr)
library (rebus)
library (readr)
library(ggraph)
library(igraph)
library(stringdist)
library(tidyverse) 
library(dplyr)
library(tm)
library(rebus)
library(tibble)
library(stringr)




###########################################################
# construction du dataframe df_bg contenant les dpeches ecrites par benedetti ou gramont
df_bg <- df_depdipfr %>%
  filter(exped=="Benedetti" |exped=="Le Duc de Gramont") %>%
  select(doc_id=num_dep,text,exped) %>%
  #nettoyage
  mutate( 
    text=str_replace_all(text,"\\'"," "),
    text=str_replace_all(text,"«","« "),
    text=str_replace_all(text,"»"," »"),
    text=str_replace_all(text,"\\("," \\( "),
    text=str_replace_all(text,"\\)"," \\) "),
    text=str_replace_all(text,"\\["," \\[ "),
    text=str_replace_all(text,"\\]"," \\] "),
    text=str_replace_all(text,"\\."," \\."),
    text=str_replace_all(text,"\\!"," \\.!"),
    text=str_replace_all(text,"\\?"," \\?"),
    text=str_replace_all(text,"\\,"," \\,"),
    text=str_replace_all(text,"\\;"," \\;"),
    text=str_replace_all(text,"\\:"," \\:"),
    text=str_replace_all(text,"â","a"),
    text=str_replace_all(text,"ô","o"),
    text=str_replace_all(text,"ç","c")
  )


#creation du dataframe df_tdm_en de forme TDM 
df_source = DataframeSource(df_bg)
df_corpus = VCorpus(df_source,readerControl = list( language = "fr"))
depeche_tdm_en = TermDocumentMatrix(df_corpus, control = list(tolower = F))
matrix_tdm_en = as.matrix(depeche_tdm_en)
df_tdm_en = as.data.frame(matrix_tdm_en)


#############################################################################


