# ce script permet de construire le vecteur vec_nom_tot_nom
# utilisé dans les script reseau4 et reseau5


setwd("D:/memoire m2_LNakache/reseau benedetti-gramont/a_importer")



# lecture de tous les  fichiers noms_tome
df_vect_nom1<-  read_delim("noms_tome1.csv", delim=",")
df_vect_nom2<-  read_delim("noms_tome2.csv", delim=",")
df_vect_nom3<-  read_delim("noms_tome3.csv", delim=",")
df_vect_nom4<-  read_delim("noms_tome4.csv", delim=",")
df_vect_nom5<-  read_delim("noms_tome5.csv", delim=",")
df_vect_nom6<-  read_delim("noms_tome6.csv", delim=",")
df_vect_nom7<-  read_delim("noms_tome7.csv", delim=",")
df_vect_nom8<-  read_delim("noms_tome8.csv", delim=",")
df_vect_nom9<-  read_delim("noms_tome9.csv", delim=",")
df_vect_nom10<- read_delim("noms_tome10.csv", delim=",")
df_vect_nom11<- read_delim("noms_tome11.csv", delim=",")
df_vect_nom12<- read_delim("noms_tome12.csv", delim=",")



# creation de df_vect_nom regroupement dans un meme dataframe
df_vect_nom <- rbind( 
  df_vect_nom1, df_vect_nom2, df_vect_nom3, df_vect_nom4,
  df_vect_nom5, df_vect_nom6, df_vect_nom7, df_vect_nom8,
  df_vect_nom9, df_vect_nom10, df_vect_nom11, df_vect_nom12) %>%
  mutate(
    # on ne simplifie pas Moltke-Nutchao ni Moltke-Hvitfeldt
    # car ils donnent tous les deux le meme nom simplifie
    nom_simplifié=ifelse(nom_simplifié=="MOLTKE",NA, nom_simplifié),
    #suppression des espaces debut et fin de chaine
    nom_origine=str_trim(nom_corrigé,"both"),
    nom_simplifie=str_trim(nom_simplifié,"both"),
    #on ne conserve que la première majuscule
    nom_origine=str_to_title(nom_origine,locale="fr"),
    nom_simplifie=str_to_title(nom_simplifie,locale="fr"),
    #flag presence d'un espace dans le nom d'origine
    b_nom_origine=str_detect(nom_origine," "),  
    id=seq(1:527)
  ) %>%
  select(id, num_tome, nom_origine, nom_simplifie,b_nom_origine) 


#nettoyage de l'environnement
rm(df_vect_nom1,df_vect_nom2,df_vect_nom3,
   df_vect_nom4,df_vect_nom5,df_vect_nom6)
rm(df_vect_nom7,df_vect_nom8,df_vect_nom9,
   df_vect_nom10,df_vect_nom11,df_vect_nom12)


#####ajout de variables #########################################################
df_vect_nom <- df_vect_nom %>%
  mutate(
    #construction de nom_final et type
    nom_final=ifelse(is.na(nom_simplifie),nom_origine,nom_simplifie),
    type=ifelse(is.na(nom_simplifie),"ori","sim"),
    #flag des noms origine dupliqués
    aexcl_nom_ori_n=duplicated(nom_origine), 
    #flag des noms simplifiés dupliqués
    aexcl_nom_sim_n=ifelse(type=="sim",aexcl_nom_ori_n,NA ), 
    #les noms origine et simplifié sont differents
    aexcl_nom_ori_n=ifelse(nom_origine %in% nom_simplifie, TRUE, aexcl_nom_ori_n)
  ) 


#### construction de df_vect_nom_tot_nom ############################################ 
df_vect_nom_a <- df_vect_nom %>%
  filter(aexcl_nom_ori_n !=TRUE) %>%
  filter(b_nom_origine==FALSE) %>%
  mutate(type="ori") %>%
  select(nom=nom_origine,type)

df_vect_nom_b <- df_vect_nom %>%
  filter(aexcl_nom_sim_n !=TRUE) %>%
  mutate(type="sim") %>%
  select(nom=nom_simplifie,type)

df_vect_nom_tot_nom <-rbind(df_vect_nom_a,df_vect_nom_b)
df_vect_nom_tot_nom <-df_vect_nom_tot_nom[order(df_vect_nom_tot_nom$nom),]
###################################################################################"

#### construction de vec_nom_tot_nom ########################################## 
vec_nom_tot_nom <- df_vect_nom_tot_nom$nom

#nettoyage de l environnement#################################################
rm(df_vect_nom_a,df_vect_nom_b)
