# ce script permet de construite t_bool_idbis dataframe 
# de 396 lignes (les depeches)
# et 469 colonnes (les noms des personnages cités dans les notices)
# la cellule vaut 1 si le personnage est cité au moins une fois dans la dépeche

# ce script comprend plusieurs étapes en raison du traitement des noms composés 


#premiere etape#############################################
#  construction de bool_id
# nrow= nombre de noms propres dans vec_nom_tot_nom
# ncol= nombre de depeches
# on construit un df vide 
# puis on le remplit par une boucle sur les depeches
# la cellule vaut 1 si le nom est cité dans la dépeche


stop = str_to_title(stopwords(kind = "fr"))
vec_nom_tot_nom <- df_vect_nom_tot_nom$nom

bool_id <- matrix(0, nrow = 523, ncol = 396)
bool_id <-as.data.frame(bool_id)

for(i in 1:length(depeches)){
  
  dfindex_id <-as.data.frame(mots) %>%
    mutate(var_temp =df_tdm_en[[i]]) %>%
    filter(var_temp> 0) %>%
    mutate(
      maj = str_detect(mots, regex("^[A-Z]")),
      stop_mots = mots %in% stop
    ) %>%
    filter(maj==TRUE & stop_mots == FALSE) 
  
  mots_maj <- as.character(dfindex_id$mots)
  
  listindex_id= sapply(vec_nom_tot_nom, amatch, mots_maj, maxDist=1,method="lv")
  bool_id[[i]] = as.numeric(if_else(is.na(listindex_id), FALSE, TRUE))
}

row.names(bool_id) <- vec_nom_tot_nom
names(bool_id)     <- depeches
###############################################



#####deuxième etape ###########################################
# on réunit les noms qui correspondent a un meme personnage
# ex Bismarck et Bismarck-Schoenhausen 
# pour cela on transpose
# on cree la variable Bismarck qui est vraie 
# si Bismarck ou Bismarck-Schoenhausen est vraie


t_bool_id <- as.data.frame(t(bool_id))
t_bool_id <- t_bool_id %>%
  mutate(
    Aristarchi=as.numeric(Aristarchi|`Aristarchi-Bey`),
    Arnim=as.numeric(Arnim|`Arnim-Boytzenbourg`),
    Auvergne=as.numeric(Auvergne|`Auvergne-Lauraguais`),
    Beaulieu=as.numeric(Beaulieu|`Beaulieu-Marconnay`),
    Bismarck=as.numeric(Bismarck|`Bismarck-Schoenhausen`),
    Bosch=as.numeric(Bosch|`Bosch-Spencer`),
    Bray=as.numeric(Bray|`Bray-Steinbourg`),
    Breidbach=as.numeric(Breidbach|`Breidbach-Burresheim`),
    Canitz=as.numeric(Canitz|`Dallwitz`),
    Chigi=as.numeric(Chigi|`Chigi-Albani`),
    Comminge=as.numeric(Comminge|`Comminge-Guitaud`),
    Degenfeld=as.numeric(Degenfeld|`Degenfeld-Scbonbourg`),
    Dirckinck=as.numeric(Dirckinck|`Dirckinck-Holmfeld`),
    Djemil=as.numeric(Djemil|`Mohamed-Djemil-Pacha`),
    Ferrières=as.numeric(Ferrières|`Ferrières-Le-Vayer`),
    Forth=as.numeric(Forth|`Forth-Rouen`),
    Frézals=as.numeric(Frézals|`Frézals-Bourfaud`),
    Fuad=as.numeric(Fuad|`Mehemed-Fuad`),
    Hohenlohe=as.numeric(Hohenlohe|`Hohenlohe-Ingelfingen`),
    Hohenzollern=as.numeric(Hohenzollern|`Hohenzollern-Sigmaringen`),
    Isembourg=as.numeric(Isembourg|`Isembourg-Budingen`),
    Keyserling=as.numeric(Keyserling|`Keyserling-Rautenbourg`),
    Larisch=as.numeric(Larisch|`Larisch-Moenich`),
    Launay=as.numeric(Launay|`Launay-Hallwyl`),
    Lobanoff=as.numeric(Lobanoff|`Lobanoff-Rostowski`),
    Meloizes=as.numeric(Meloizes|`Meloizes-Fresnoy`),
    Mensdorff=as.numeric(Mensdorff|`Mensdorff-Pouilly`),
    Metternich=as.numeric(Metternich|`Metternich-Winneburg`),
    Moreau=as.numeric(Moreau|`Moreau-Faverney`),
    Musurus=as.numeric(Musurus|`Musurus-Bey`),
    Ottenfels=as.numeric(Ottenfels|`Ottenfels-Gschwind`),
    Perponcher=as.numeric(Perponcher|`Perponcher-Sedlnitzky`),
    Petitti=as.numeric(Petitti|`Petitti-Bagliani`),
    Pfusterschmid=as.numeric(Pfusterschmid|`Pfusterschmid-Hartenstein`),
    Pirch=as.numeric(Pirch|`Pirch-Wobensin`),
    Platen=as.numeric(Platen|`Platen-Hallermund`),
    Prokesch=as.numeric(Prokesch|`Prokesch-Osten`),
    Quadt=as.numeric(Quadt|`Quadt-Wykradt-Isny`),
    Quigini=as.numeric(Quigini|`Quigini-Puliga`),
    Rechberg=as.numeric(Rechberg|`Rechberg-Rothenloewen`),
    Revertera=as.numeric(Revertera|`Revertera-Salandra`),
    Rosetti=as.numeric(Rosetti|`Rosetti-Balanesco`),
    Salignac=as.numeric(Salignac|`Salignac-Fénelon`),
    Scheel=as.numeric(Scheel|`Scheel-Plessen`),
    Schulenbourg=as.numeric(Schulenbourg|`Schulenbourg-Priemern`),
    Solms=as.numeric(Solms|`Solms-Sonnenwalde`),
    Syan=as.numeric(Syan|`Sayn-Wittgenstein-Berlebourg`),
    Talleyrand=as.numeric(Talleyrand|`Talleyrand-Périgord`),
    Thumb=as.numeric(Thumb|`Thumb-Neubourg`),
    Thun=as.numeric(Thun|`Thun-Hohenstein`),
    Ungern=as.numeric(Ungern|`Ungern-Sternberg`),
    Uxkull=as.numeric(Uxkull|`Uxkull-Gyllenband`),
    Visconti=as.numeric(Visconti|`Visconti-Venosta`),
    Wedel=as.numeric(Wedel|`Wedel-Jarlsberg`),
    Wullerstorff=as.numeric(Wullerstorff|`Wullerstorff-Urbair`)
  ) 
row.names(t_bool_id) <- depeches
###############################################




#troisième étape ##############################################
#on ne conserve que les noms correspondant à des noms simplifiés 

bool_idbis <-as.data.frame(t(t_bool_id))  #ok
bool_idbis <- bool_idbis %>%
  mutate(nom_final =row.names(bool_idbis))%>%
  filter (nom_final %in%  df_vect_nom$nom_final) 

row.names(bool_idbis)<- bool_idbis$nom_final
bool_idbis <- bool_idbis %>% select(-nom_final)
###################################################



#quatrieme etape################################################### 
#on transpose de nouveau pour avoir le data frame dans la forme desirée
#et on ajoute la colonne exped

t_bool_idbis<- as.data.frame(t(bool_idbis)) %>%
  mutate(exped=df_bg$exped) %>%
  select(exped, Aali:Zuylen) 
row.names(t_bool_idbis)<-depeches
##fin quatrieme etape################################################################


