# ce script permet de construire le graphe des ego-reseaux


# constructin de df_adj dataframe pratiquement idenditique a t_bool_idbis
# mais dans lequel les cellules doivent etre en numerique 
# et les noms de variables ne peuvent pas contenir d'accent
df_adj<-t_bool_idbis
df_adj[2:ncol(df_adj)] <- lapply(df_adj[2:ncol(df_adj)], function(x) as.numeric(as.character(x)))
names(df_adj) = iconv(names(df_adj),from="UTF-8",to="ASCII//TRANSLIT")


# construction du dataframe weighted_edges_gb
# donnant pour chaque ambassadeurs le nombre de depeches 
# dans lesquelles un personnage est cité au moins une fois
weighted_edges_gb = df_adj %>% 
  group_by(exped) %>% 
  summarise_each(funs(sum)) %>%
  gather(key = "mention", value ="f", names(df_adj)[2:ncol(df_adj)]) %>%
  filter(f>0) %>%
  arrange(desc(f))


# nettoyage du dataframe weighted_edges_gb
weighted_edges_gb <- weighted_edges_gb %>%
  mutate(mention=ifelse(mention=="Forth","Forth-Rouen",mention),
         mention=ifelse(mention=="Marmora","La Marmora",mention),
         mention=ifelse(mention=="Torre","La Torre",mention),
         mention=ifelse(mention=="Valette","La Valette",mention),
         mention=ifelse(mention=="Rochefoucauld","La Rochefoucauld",mention),
         mention=ifelse(mention=="Auvergne","La Tour d Auvergne",mention),
         mention=ifelse(mention=="Boeuf","Le Boeuf",mention),
         mention =ifelse(mention=="Behaine","Lefebvre de Béhaine",mention),
         mention =ifelse(mention=="Gramont","Le Duc de Gramont",mention)
  ) %>%
  filter(exped!=mention) %>%
  filter(mention!="Couronnel" & mention!="Drouyn" & mention!="Hesse"
         & mention!="Plate" & mention!="Bille" & mention!="Linden" & mention!="Moltke" )


#transformation en objet graphe
EN_graph_gb <- weighted_edges_gb %>% graph_from_data_frame()


# plot du graphe des ego reseaux
set.seed(2017)
ggraph(EN_graph_gb, layout = "fr") +  #Fruchterman-Reingold layout algorithm
  geom_edge_link(aes(edge_alpha=f)) +
  geom_node_point() +
  geom_node_text(aes(label = name), vjust = 1, hjust = 1)+
  theme_void()

#####construction du df weighted_edges_gb_g : personnages cités par gramont 
weighted_edges_gb_g  <- weighted_edges_gb %>%  filter(exped=="Le Duc de Gramont")
#####construction du df weighted_edges_gb_b : personnages cités par benedetti 
weighted_edges_gb_b  <- weighted_edges_gb %>%  filter(exped=="Benedetti")








